//  Copyright (c) 2013 Open Planet Software. All rights reserved.


varying vec2 texCoordVarying;
 
uniform sampler2D sourceImage;
uniform vec4 inputs;
uniform vec4 keyColour;

void main()
{
    float threshold = inputs.x;
    float smoothing = inputs.y;
    float cutoff = inputs.z;

    vec3 colorToReplace = keyColour.xyz;

    vec4 textureColor = texture2D(sourceImage, texCoordVarying);

    float maskY = 0.2989 * colorToReplace.r + 0.5866 * colorToReplace.g + 0.1145 * colorToReplace.b;
    float maskCr = 0.7132 * (colorToReplace.r - maskY);
    float maskCb = 0.5647 * (colorToReplace.b - maskY);

    float Y = 0.2989 * textureColor.r + 0.5866 * textureColor.g + 0.1145 * textureColor.b;
    float Cr = 0.7132 * (textureColor.r - Y);
    float Cb = 0.5647 * (textureColor.b - Y);

    float blendValue = smoothstep(threshold, threshold + smoothing, distance(vec2(Cr, Cb), vec2(maskCr, maskCb)));

    blendValue = step( cutoff, blendValue );
    gl_FragColor = vec4( textureColor.rgb, blendValue );
}
